///////////////////////////////////////////////////////////////////////////
// Workfile : ATtiny2313.c
// Author : Georg Gschwandtner, Hubert Gschwandtner
// Date : 17. 07. 2011
// Description : Testprogramm fr ATMEL Evaluationsboard
// Remarks : Tasten-HW gendert, schalten nach GND
// Revision : 0
///////////////////////////////////////////////////////////////////////////

#include <avr/io.h> 
#include "uart.h"
#include <util/delay.h>
#include <avr/interrupt.h>
#define UART_BAUD_RATE     2400 // Bautrate UART    

int main(void){
	DDRD= (1<<DDD5)|(1<<DDD6);			// Ausgnge aktiv
	PORTD= (1<<PD2)|(1<<PD3)|(1<<PD4); // PullUp aktiv
	uart_init(UART_BAUD_SELECT(UART_BAUD_RATE,F_CPU));  //UART parametrieren
	sei(); // Interaptaktivierung
	char flag1 = 0; // Flag fr die Stromstossausfuehrung
	char flag2 = 0;
for(;;){
	if (!(PIND & (1<<PIND2))){ // LED1 als Stromstoss ausfuerung
		if ((PIND & (1<<PIND5))&& (flag1== 0)){
			PORTD &=~ (1<<PD5);
		}
		else{
			if(!(PIND & (1<<PIND5))&& (flag1== 0)){
				PORTD |= (1<<PD5);
			}
		}
		flag1 = 1;
		_delay_ms(10);
	}
	else{
		flag1=0;
	}
	
	if (!(PIND & (1<<PIND3))){ // LED2 als Stromstoss ausfuerung
		if ((PIND & (1<<PIND6))&& (flag2== 0)){
			PORTD &=~ (1<<PD6);
		}
		else{
			if(!(PIND & (1<<PIND6))&& (flag2== 0)){
				PORTD |= (1<<PD6);
			}
		}
		flag2 = 1;
		_delay_ms(10);
	}
	else{
		flag2=0;
	}
	if (!(PIND & (1<<PIND4))){ // LED1
		for ( int i = 0; i<5;i++){ // Blinklicht LD1 und LD2
			PORTD |= (1<<PD5); 
			_delay_ms(400); //Leuchtdauer LD1
			PORTD &=~ (1<<PD5);
			PORTD |= (1<<PD6);
			_delay_ms(400); //Leuchtdauer LD2
			PORTD &=~ (1<<PD6);
		}
	 uart_puts("Atmel-Evaluation-Board");	
	}
}
}

